member
_ABCDllMode_  EQUATE(0)
_ABCLinkMode_ EQUATE(1)

 Map
   module('api')
   memcpy(long,long,long),long,proc,name('_memcpy')
   SysFreeString(long),long,pascal,proc

   end
 end

!Includes this class and others
 include('ISaxCl.inc')

!global data for this module
Return:benign equate(0)
Return:Fatal  equate(3)
Return:Notify equate(5)



!equates for various features one can ask about
efeatureValidating equate('http://xml.org/sax/features/validation')
efeatureNamespace  equate('http://xml.org/sax/features/namespace-prefixes')


ISaxAttributesType  Interface(IUNKnowntype),com,type
getLength           procedure(*signed pnLength),hresult
getUri              procedure(signed nIndex, *long lpURI, *signed ccURI),hresult
getLocalName        procedure(signed nIndex, *long lpLocalName, *signed ccLocalName),hresult
GetQName            procedure(signed nIndex, *long lpQName, *signed ccQName),hresult
getName             procedure(signed nIndex, *long lpuri, *signed ccURI, *long lpLocalName, *signed ccLocalName, *long lpQName, *signed ccQName),hresult
getIndexFromName    procedure(long lpURI, signed ccURI, long lpLocalName, signed ccLocalName, *signed nIndex),hresult
GetIndexFromQName   procedure(long lpQname,signed ccQname, *signed nIndex),hresult
getType             procedure(signed nIndex, *long lpType, *signed ccType),hresult
getTypeFromName     procedure(long lpURI, signed ccUri, long lpLocalName, signed ccLocalName, *long lpType, *signed ccType),hresult
GetTypeFromQName    procedure(long lpQName, signed ccQname, *long lpType, *signed cctype),hresult
getValue            procedure(signed nIndex, *long lpValue, *signed ccValue),hresult
GetValueFromName    procedure(long lpUri, signed ccUri, long lpLocalName, signed ccLocalName, *long lpValue, *signed ccValue),hresult
GetValueFromQName   procedure(long lpQname, signed ccQName, *long lpValue, *signed ccValue),hresult
        end
ISaxLocatorType     Interface(IUnknowntype),com,type
getcolumnnumber     procedure(*signed nCol),hresult
getLineNumber       procedure(*signed nLine),hresult
getPublicID         procedure(*long lpPublicID),hresult
getSystemID         procedure(*long lpSystemId),hresult
  end


!List of IIDS, and CLSIDS
IID_ISaxReader group
!A4F96ED0-F829-476E-81 C0-CD C7 BD 2A 08 02
data1       ulong(0A4F96ED0H)
data2       ushort(0F829H)
data3       ushort(476EH)
data41      byte(81H)
data42      byte(0C0H)
data43      byte(0CDH)
data44      byte(0C7H)
data45      byte(0BDH)
data46      byte(02AH)
data47      byte(008H)
data48      byte(002H)
  end
CLSID_ISax  Group
!079aa557-4a18-424a-8eee-e39f0a8d41b9
data1       ulong(079aa557H)
data2       ushort(4a18H)
data3       ushort(424aH)
data41      byte(8eH)
data42      byte(0eeH)
data43      byte(0e3H)
data44      byte(09fH)
data45      byte(0aH)
data46      byte(08dH)
data47      byte(041H)
data48      byte(0B9H)
  end




!-------------------------------------------------------------
!---Start of ISaxClass
!-------------------------------------------------------------
ISaxClType.Init                Procedure(string pXMLSourceURL, byte pDebugMode=0) !,byte,proc
Res         byte,auto
thetime     long,auto
IsRunning   short,auto
boolResult  byte,auto
lpISaxReader long,auto
    code
    SELF.debugmode=pDebugmode  !0=dont show messages

    !make the stdcom class
    SELF.StdComCl&=New StdComclType
    if SELF.StdComCl&=NULL then return return:fatal.

    !call coinit to initialize com on this thread, call couninit later
    SELF.StdComCl.InitCom()

    !use the clsid for ISax to get the address of an ISaxReader interface.
    lpISaxReader=SELF.StdComCl.GetInterface(address(Clsid_ISax), address(IID_ISaxReader))
    if ~lpISaxReader then return return:fatal.
    SELF.ISaxReader &=(lpISaxReader) !Ready to call ISax reader


    !if cocreate worked then create all the other classes and interfaces we need
    if lpISaxReader then
      !string class for CW to wide string conversion
      SELF.StrCl &= NEW StrClType

      !create the class and interface the ISaxXMLReader Interface will call
      SELF.ISaxContentCl &= New ISaxcontentClType

      !Create the class and interface for handling errors - ISaxXMLReader will call it on errors
      SELF.ISaxErrorHandlerCl &= New ISaxErrorHandlerClType

      !if new failed, then get out of here
      If SELF.StrCl&=NULL or SELF.ISaxContentCl&=NULL or SELF.ISaxErrorHandlerCl&=NULL then Return Return:Fatal.

      !intialize the ISaxContentCl
      SELF.ISaxContentCl.ISaxCl&=SELF
      SELF.ISaxContentCl.StrCl&=New StrClType
      SELF.ISaxContentCl.DebugMode=SELF.DebugMode

      !intialize the ISaxErrorHandlerCl
      SELF.ISaxErrorHandlerCl.ISaxCl&=SELF
      SELF.ISaxErrorHandlerCl.StrCl&= New StrClType
      SELF.ISaxErrorHandlerCl.DebugMode=SELF.DebugMode

      !if new failed exit
      If SELF.ISaxErrorHandlerCl.StrCl&=NULL or SELF.ISaxContentCl.StrCl&=NULL then Return Return:Fatal.

      !if everything is okay then pass the errorhandler and content Interfaces to the ISaxXMLReader Interface
      if ~Res Then  res=SELF.SetErrorHandler().
      if ~res then  res=SELF.SetContentHandler().

      !this starts the actual parcing of the file
      if ~res then  res=SELF.parceURL(pXMLSourceURL).
    end

    !if the error handler class was invoked then SELF.ErrorMsg was set.
    if ~Res and SELF.ErrorNum then
      if SELF.Debugmode then Message(SELF.ErrorMsg,'XML Parcing Failed').
      Res=Return:Fatal
    end

    !if ISaxReader was created, then release it
    if lpISaxReader then
      SELF.ISaxReader.Release()  !this disposes of the Isaxreader object we create by calling cocreateinstance
    end
    return(res)

ISaxClType.setContentHandler  procedure()
res byte(return:benign)
hr  hresult
  code
  hr=SELF.ISaxReader.PutContentHandler(address(SELF.ISaxContentCL.ISaxcontent))
  if hr<0 then
    res=return:fatal
  end
  Return res

ISaxClType.setErrorHandler  procedure()
res byte(return:benign)
hr  hresult
  code
  hr=SELF.ISaxReader.PutErrorHandler(address(SELF.ISaxErrorHandlerCL.ISaxErrorHandler))
  if hr<0 then
    res=return:fatal
  end
  Return res

ISaxClType.ParceURL           Procedure(*string pXMLSOURCEURL)
res byte(return:benign)
wURL &String
hr  hresult
  code
  if ~pXMLSourceURL then return return:fatal.
  wurl&=SELF.StrCl.CWToWideStralloc(pXMLSourceURL)
  hr=SELF.ISaxReader.ParceUrl(address(wURL))
  dispose(wURL)
  if hr<0 then
    res=return:fatal
  end
  return res

ISaxClType.GetFeature         Procedure(String pFeature, *byte pTrueFalse)!,byte,proc
res byte(0)
wFeature &string
trueFalse short,auto !variant_bool
hr hresult,auto
  code
  if ~pFeature then return return:fatal.
  wFeature&=SELF.StrCl.CWToWideStralloc(pFeature)
  hr=SELF.ISaxReader.GetFeature(address(wFeature), TrueFalse)
  dispose(wFeature)
  if hr<0 then
    res=return:fatal
  end
  pTrueFalse=choose(TrueFalse=-1,1,0)
  Return res

ISaxClType.PutFeature         Procedure(String pFeature, byte pTrueFalse)!,byte,proc
res byte(0)
wFeature &string
hr hresult
  code
  if ~pFeature then return return:fatal.
  wFeature&=SELF.StrCl.CWToWideStralloc(pFeature)
  !65535=-1=0FFFFH as a short (variant_bool)
  hr=SELF.ISaxReader.PutFeature(address(wFeature),choose(pTrueFalse=0,0,65535))
  dispose(wFeature)
  if hr<0 then
    res=return:fatal
  end
  Return res

ISaxClType.Kill      Procedure()
  code
  Dispose(SELF.StrCl)
  if ~SELF.ISaxcontentCl&=NULL then
    dispose(SELF.ISaxContentCl.StrCL)
    Dispose(SELF.ISaxContentCl)
  end
  If ~SELF.ISaxErrorHandlerCl&=Null then
    dispose(SELF.ISaxErrorhandlerCl.StrCl)
    Dispose(SELF.ISaxErrorHandlerCl)
  end
  if ~SELF.StdComCl &= NULL then
    SELF.StdComCl.killCom()
    dispose(SELF.StdComCl)
  end
  Return

ISaxcontentCLType.ISaxcontent.QueryInterface           PROCEDURE (long riid  ,*LONG ppvobj)!,HRESULT
  code
  Message('QueryInterface was unexpectedly called.')
  return 0

ISaxcontentclType.ISaxcontent.AddRef                   PROCEDURE ()!,HRESULT
  code
  SELF.RefCount+=1
  !Message(self.rEFcOUNT,'addref')
  return SELF.RefCount

ISaxcontentclType.ISaxcontent.Release                  PROCEDURE ()!,HRESULT,PROC
  code
  SELF.RefCount-=1
  !message(self.rEFcOUNT,'realease')
  return SELF.RefCount

ISaxcontentclType.ISaxcontent.documentLocator          Procedure(long lpLocatorObj)!,hresult !in parameter
  code
  SELF.ISaxCl.DocumentLocator(lpLocatorObj)
  return 0

ISaxcontentclType.ISaxcontent.StartDocument            Procedure()!,hresult
  code
  SELF.ISaxCl.StartDocument()
  return 0

ISaxcontentclType.ISaxcontent.EndDocument              Procedure()!,hresult
  code
  SELF.ISaxCl.EndDocument()
  return 0

ISaxcontentclType.ISaxcontent.StartPrefixMapping      Procedure(long lpWPrefix, long cbPrefix, long lpWURI, long cbURI)
res    byte,auto
prefix &string
uri    &string
  code
  prefix&=SELF.StrCl.WideStrToCWAlloc(lpwprefix,res,cbprefix)
  if ~res then uri&=SELF.StrCl.WideStrToCWAlloc(lpWURI,res,cbURI).
  if ~res then res=SELF.ISaxCl.StartPrefixMapping(Prefix,uri).
  dispose(uri)
  dispose(prefix)
  if res and SELF.DebugMode  then message('startprefix failed').
  return Choose(res=0,0,E_Fail)

ISaxcontentclType.ISaxcontent.EndPrefixMapping        Procedure(long lpWPrefix, long cbPrefix)
res byte,auto
prefix &string
  code
  prefix&=SELF.StrCl.WideStrToCWAlloc(lpwPrefix,res,cbPrefix)
  if ~res then res=SELF.ISaxCl.EndPrefixMapping(prefix).
  dispose(prefix)
  if res and SELF.DebugMode  then message('endprefix failed').
  return Choose(res=0,0,E_Fail)

ISaxcontentclType.ISaxcontent.StartElement            Procedure(long lpWNamespaceURI, long cbNameSpaceURI, long lpWLocalName, long cbLocalName, long lpWQName, long cbQName, long lpObjAttributes)
res byte(0)
NameSpaceURI &string
LocalName    &string
QName        &String
AttribValue  &String
AttribName   &String
count        long  !number of attributes
lpAttr       long  !ptr to the attributes
cbAttr       long  !size of the attributes
I            long  !counter loop thru attributes
ISaxAttributes  &ISaxAttributesType
  code
  NameSpaceuri&=SELF.StrCl.WideStrToCwAlloc(lpwNamespaceURI,res,cbNameSpaceURI)
  if ~res then localname&=SELF.StrCl.WideStrToCwAlloc(lpwLocalName,res,cbLocalName).
  if ~res then QName&=SELF.StrCl.WideStrToCWAlloc(lpwQName,res,cbQName).
  if ~res then res=SELF.ISaxCl.StartElement(NameSpaceURI,Localname,QName).
  dispose(namespaceuri)
  dispose(localname)
  dispose(qname)
  if res and SELF.DebugMode then message('startelement failed').
  if ~res and lpObjAttributes then
      ISaxAttributes &= (lpObjAttributes)

      !call addref so the caller knows we're using it
      ISaxAttributes.AddRef()

      !get the number of attributes
      If ISaxAttributes.GetLength(Count)>=0 then
        loop I=0 to count-1
          !get the attributevalue and convert to a CW string
          if ISaxAttributes.GetValue(I,lpAttr,cbAttr)>=0 then
            AttribValue&=SELF.StrCl.WideStrToCWAlloc(lpAttr,res,cbAttr)
          end
          !Get the Attribute name and convert to a CW string
          if ISaxAttributes.GetQName(I,lpAttr,cbAttr)>=0
            AttribName&=SELF.StrCl.WideStrToCWAlloc(lpAttr,res,cbAttr)
          end
          !pass the attribute name and value back to the ISaxCl by calling the attribute method
          !set the last parameter to true when the last parameter is passed otherwise false
          SELF.IsaxCl.Attribute(I, AttribName, AttribValue, choose(I=count-1,1,0))
          dispose(AttribValue)
          dispose(AttribName)
          if res then break.
        end !loop
        if res and SELF.DebugMode then Message('Get Attributes failed').
      end !if can get a count
      ISaxAttributes.Release()
  end
  return Choose(res=0,0,E_Fail)

ISaxcontentclType.ISaxcontent.EndElement              Procedure(long lpWNameSpaceURI, long cbNameSpaceURI, long lpWLocalName, long cbLocalName, long lpWQName, long cbQName)
res byte(0)
NameSpaceURI &string
LocalName    &string
QName        &String
  code
  NameSpaceuri&=SELF.StrCl.WideStrToCwAlloc(lpwNamespaceURI,res,cbNameSpaceUri)
  if ~res then localname&=SELF.StrCl.WideStrToCwAlloc(lpwLocalName,res,cbLocalName).
  if ~res then QName&=SELF.StrCl.WideStrToCWAlloc(lpwQName,res,cbQName).
  if ~res then res=SELF.ISaxCl.EndElement(NameSpaceURI,Localname,QName).
  dispose(namespaceuri)
  dispose(localname)
  dispose(qname)
  if res and SELF.DebugMode  then message('endelement failed').
  return Choose(res=0,0,E_Fail)

ISaxcontentclType.ISaxcontent.Characters              Procedure(long lpWChars, long cbChars)
res byte(0)
chars &string
  code
  chars&=SELF.StrCl.WideStrToCWAlloc(lpwChars,res,cbChars)
  if ~res then res=SELF.ISaxCl.Characters(Chars).
  dispose(chars)
  if res and SELF.DebugMode  then message('characters failed').
  return Choose(res=0,0,E_Fail)

ISaxcontentclType.ISaxcontent.ignoreableWhitespace    Procedure(long lpWchars, long cbChars)
res byte(0)
chars &string
  code
  chars&=SELF.StrCl.WideStrToCWAlloc(lpwChars,res,cbChars)
  if ~res then res=SELF.ISaxCl.IgnoreableWhiteSpace(Chars).
  dispose(chars)
  if res and SELF.DebugMode  then message('ignorewhite failed').
  return Choose(res=0,0,E_Fail)

ISaxcontentclType.ISaxcontent.processingInstruction   Procedure(long lpWTarget, long cbTarget, long lpWData, long cbData)
res byte(0)
wtarget &string
wData &string
  code
  wTarget&=SELF.StrCl.WideStrToCWAlloc(lpwTarget,res,cbTarget)
  if ~res then wData&=SELF.StrCl.WideStrToCWAlloc(lpwData,res,cbData).
  if ~res then res=SELF.ISaxCl.ProcessingInstruction(wTarget,wData).
  dispose(wtarget)
  dispose(wdata)
  if res and SELF.DebugMode  then message('PI failed').
  return Choose(res=0,0,E_Fail)

ISaxcontentclType.ISaxcontent.SkippedEntity           Procedure(long lpWName, long cbName)
res byte(0)
wname &string
  code
  wname&=SELF.StrCl.WideStrToCWAlloc(lpwname,res,cbName)
  if ~res then res=SELF.ISaxCl.SkippedEntity(wname).
  dispose(wname)
  if res and SELF.DebugMode  then message('skip failed').
  return Choose(res=0,0,E_Fail)

ISaxErrorHandlerCLType.ISaxErrorHandler.QueryInterface           PROCEDURE (long riid  ,*LONG ppvobj)!,HRESULT
  code
  Message('QueryInterface error handler was unexpectedly called.')
  return 0

ISaxErrorHandlerclType.ISaxErrorHandler.AddRef                   PROCEDURE ()!,HRESULT
  code
  SELF.RefCount+=1
  !Message(self.rEFcOUNT,'addref')
  return SELF.RefCount

ISaxErrorHandlerclType.ISaxErrorHandler.Release                  PROCEDURE ()!,HRESULT,PROC
  code
  SELF.RefCount-=1
  !message(self.rEFcOUNT,'realease')
  return SELF.RefCount
ISaxErrorHandlerclType.ISaxErrorHandler.Error                    Procedure(long pObjLocator, long lpErrorMessage, long pErrorCode)
EM &string
Res byte(0)
  code
  EM&=SELF.StrCl.WideStrToCWAlloc(lpErrorMessage,res)
  res=SELF.ISaxCl.ErrorHandler('Error',pObjLocator,EM, pErrorCode)
  dispose(EM)
  return Choose(res=0,0,E_Fail)

ISaxErrorHandlerclType.ISaxErrorHandler.FatalError               Procedure(long pObjLocator, long lpErrorMessage, long pErrorCode)
EM &string
Res byte(0)
  code
  EM&=SELF.StrCl.WideStrToCWAlloc(lpErrorMessage,res)
  res=SELF.ISaxCl.ErrorHandler('Fatal',pObjLocator,EM, pErrorCode)
  dispose(EM)
  return Choose(res=0,0,E_Fail)

ISaxErrorHandlerclType.ISaxErrorHandler.IgnorableWarning         Procedure(long pObjLocator, long lpErrorMessage, long pErrorCode)
EM &string
Res byte(0)
  code
  EM&=SELF.StrCl.WideStrToCWAlloc(lpErrorMessage,res)
  res=SELF.ISaxCl.ErrorHandler('Ignorable',pObjLocator,EM, pErrorCode)
  dispose(EM)
  return Choose(res=0,0,E_Fail)




!---------- Methods that Receive parced XML ---------------
ISaxClType.DocumentLocator         Procedure(long pdoclocator)
Numcol long,auto
numline long,auto
  code
  if ~SELF.ReadLocator(pDocLocator,numcol,numline) then
  !  if SELF.Debugmode then message('Line='&numline&'|Column='&numcol,'documentlocator').
  end
  return

ISaxClType.StartDocument           Procedure()
  code
!  if SELF.Debugmode then message('startDocument').
  return

ISaxClType.EndDocument             Procedure()
  code
  !this isnt called if there is a fatal error so any cleanup done here should be done in the error handler also
!  if SELF.Debugmode then Message('endDocument').
  return

ISaxClType.StartPrefixMapping      Procedure(*String Prefix, *String URI)!,byte,proc
  code
  if SELF.Debugmode then Message('prefix='&prefix&'|uri='&uri,'startprefixmappeing').
  return return:benign

ISaxClType.EndPrefixMapping        Procedure(*String Prefix)!,byte,proc
  code
  if SELF.Debugmode then Message('prefix='& prefix,'endprefixmapping').
  return return:benign

ISaxClType.StartElement            Procedure(*String NamespaceURI, *String LocalName, *String QName)!,byte,proc
  code
  SELF.Inelement=True
  clear(SELF.ElementText)
!  if SELF.Debugmode then Message('Namespace='&clip(Namespaceuri)&'|localname='&localname&'|qname='&Qname,'startelement').
  return return:benign

ISaxClType.Attribute               procedure(long I, *string AttribName, *String AttribValue, byte IsLastAttrib)!,byte,proc
  code
  if SELF.Debugmode then Message('Name='&attribName&'||value='&attribValue&choose(IsLastAttrib=0,'','||This is the last Attribute')).
  return return:benign

ISaxClType.EndElement              Procedure(*String NameSpaceURI, *String LocalName, *string QName)!,byte,proc
  code
  SELF.Inelement=False
  clear(SELF.ElementText)
  !if SELF.Debugmode then Message('Namespace='&clip(Namespaceuri)&'|localname='&localname&'|qname='&Qname,'endelement').
  return return:benign

ISaxClType.Characters              Procedure(*String Chars)!,byte,proc
  code
  !may be called several times in a row - parcer passes only a maximum fixed amount per call. If the text exceeds that amount,
  ! then multiple calls are needed.
  !if SELF.Debugmode and chars then Message('Characters='&clip(chars)&'|len='&len(chars)&'|val='&val(Chars[1]),'characters').
  if SELF.inElement then
    SELF.ElementText=SELF.ElementText & Chars
  end
  return return:benign

ISaxClType.ignoreableWhitespace    Procedure(*String chars)!,byte,proc
  code
  !called if validated
  if SELF.Debugmode and chars then Message('ignoreablewhitespace='&chars).
  return return:benign

ISaxClType.processingInstruction   Procedure(*String pTarget, *String pData)!,byte,proc
  code
  !not called if validating
  if SELF.Debugmode then Message('TARGET='&PTARGET&'|DATA='&PDATA,'PI').
  return return:benign

ISaxClType.SkippedEntity           Procedure(*string pName)!,byte,proc
  code
  !called if non-validating
  if SELF.Debugmode then mESSAGE('SKIPPEDENTITY='&PNAME).
  return return:benign

ISaxClType.ReadLocator             procedure(long lpLocator, *long pColumn, *long pLine)
res byte(Return:Fatal)
ISaxLocator &ISaxLocatorType
  code
  if ~lpLocator then return res.
  ISaxLocator&=(lpLocator)

  !we let the locator know we are using it so it doesnt self destruct
  ISaxLocator.AddRef()

  if ISaxLocator.GetColumnNumber(pColumn)<0 then
    ISaxLocator.release()
    clear(pColumn)
    clear(pLine)
    return res
  end

  if ISaxLocator.getLineNumber(pLine)<0 then
    ISaxLocator.release()
    clear(pLine)
    clear(pcolumn)
    return res
  end

  !let the locator know we are done with it and it can self destruct
  ISaxLocator.release()
  return return:benign

ISaxClType.ErrorHandler            Procedure(string pLevel, long pobjlocator, *string em, long pErrorcode)
numcol long(0)
numrow long(0)
rowColValid byte(0)
  code
  if ~SELF.ReadLocator(pObjLocator,numcol,numrow) then
    rowColValid=true
  end
  if SELF.DebugMode then Message('Level='& pLevel & '|Msg='&em &'|ErrorCode='&pErrorCode&'|at row='&numrow&'  col='&numcol).
  if pLevel<>'Ignorable' and SELF.ErrorLevel<>'Fatal' then
    SELF.ErrorMsg=clip(Em) & 'The error happened at line '& numrow & ' and column ' & numcol & '.'
    SELF.ErrorNum=pErrorCode
    SELF.ErrorLevel=pLevel
  end
  Return Return:Benign
